* ----------------------------------------------------------------------
* 
* ----------------------------------------------------------------------

      subroutine bound(xbound, value)

* ----------------------------------------------------------------------
* Variable format transform  from char(80) to real*8
*   in - xbound : character(80) vector
*   out- value  : double precision (real*8) value
* ----------------------------------------------------------------------
      implicit none
      character*90 SCCSID
      character*80 xbound
      real*8       xval
      real*8       deg
      real*8       min
      real*8       value
      integer*4    bkt
      integer*4    ekt
      integer*4    ilen
      integer*4    iflag
      integer*4    b(50)
      integer*4    e(50)
      integer      ii
      integer*4    ival
      integer*4    lnblnk

      SCCSID="@(#)bound.f	1.1	2004/06/03 NGS"
      bkt = 0
      ekt = 0

* ------------------------------------------------
* Search for the beginnings and endings of numbers,
* assuming only that we'll find 
* numbers('0'...'9'), spaces(' '), and decimals('.').
* Comma delimited data will not work
* ------------------------------------------------
      ilen = lnblnk(xbound)

      if(xbound(1:1).ne.' ') then
        bkt = bkt + 1
        b(bkt) = 1
      endif
 
      do 1 ii=2,ilen
        if(xbound(ii:ii).eq.' ')then
          if(xbound(ii-1:ii-1).ne.' ')then
            ekt = ekt + 1
            e(ekt) = ii-1
          endif
        else
          if(xbound(ii-1:ii-1).eq.' ')then
            bkt = bkt + 1
            b(bkt) = ii
          endif
        endif
    1 continue

* ------------------------------------------------
* Count the last space as an end,
* since we've already defined it's length
* as the last non-space character
* ------------------------------------------------
      ekt    = ekt + 1
      e(ekt) = ii-1

      if(bkt .ne. ekt)stop 80808

* Integer/Decimal Degrees (1 number)
      if(bkt .eq. 1)then
       
* The following line doesn't work on old FORTRAN compilers
*         read(xbound,*)deg

        call val(xbound(b(1):e(1)),iflag,ival,xval)
        if(iflag.eq.0)deg = ival
        if(iflag.eq.1)deg = xval
        value = deg

* Integer Degrees & Integer/Decimal minutes (2 numbers)
      elseif(bkt .eq. 2)then

* The following line doesn't work on old FORTRAN compilers
*        read(xbound,*)deg,min

        call val(xbound(b(1):e(1)),iflag,ival,xval)
        if(iflag.eq.0)deg = ival
        if(iflag.eq.1)deg = xval

        call val(xbound(b(2):e(2)),iflag,ival,xval)
        if(iflag.eq.0)min = ival
        if(iflag.eq.1)min = xval

        value = deg+(min/60.d0)
      
* Otherwise there's an error and the boundaries must be re-input
      else
        value = -9999.d0
      endif

      return
      end
c
